public class Question1 {
    public static void go(String task) {
        // Task 1: arg = 100 - 100 is *not* a String, so Bepa.doTheThing(Object)
        // is called, which in turn ignores Bepa's overridden doTheThing(String)
        // and instead calls Apa.doTheThing(String) using the super keyword.
        if(task.equals("task a")) { new Bepa().doTheThing(100); }

        // Task 2: ignoring arg - "the thing" is a string, so the method
        // Bepa.doTheThing(String) is called.
        if(task.equals("task b")) { new Bepa().doTheThing("the thing"); }

        // Task 3: 47 - getValue is inherited from Bepa, which returns
        // super.value, which in turn refers to Apa.value.
        if(task.equals("task c")) { new Cykel().printValuePlus(5); }

        // Task 4: no, interfaces can't have constructors.
    }
}

abstract class Apa {
    protected int value = 0;

    public Apa(int value) {
        this.value = value;
    }

    public abstract int getValue();

    public void doTheThing(String arg) {
        System.out.println("arg = " + arg);
    }
}

class Bepa extends Apa {
    public Bepa() {
        super(42);
    }

    public int getValue() {
        return super.value;
    }

    public void doTheThing(String arg) {
        System.out.println("ignoring arg");
    }

    public void doTheThing(Object arg) {
        super.doTheThing(arg.toString());
    }
}

class Cykel extends Bepa {
    private int value = 1000;

    public void printValuePlus(int extra) {
        System.out.println(this.getValue() + extra);
    }
}
