enum PokemonType {Fire, Water, Plant};

interface Pokemon {
    PokemonType getType();
    String getName();
}

// Task a
abstract class FighterPokemon implements Pokemon {
    public boolean canDefeat(Pokemon opponent) {
        if(this.getType() == PokemonType.Plant) {
            return opponent.getType() != PokemonType.Fire;
        } else if(this.getType() == PokemonType.Fire) {
            return opponent.getType() != PokemonType.Water;
        } else {
            return opponent.getType() != PokemonType.Plant;
        }
    }
}

// Task b: when an abstract class implements an interface, any non-implemented
// methods become abstract, just like explicitly abstract methods.

// Task c
abstract class LeveledPokemon extends FighterPokemon {
    private int level;
    public LeveledPokemon(int level) {
        this.level = level;
    }

    public boolean canDefeat(LeveledPokemon opponent) {
        if(this.getType() == opponent.getType()) {
            return this.level >= opponent.level;
        }
        return super.canDefeat(opponent);
    }
}

// Task d
class MyPokemon extends LeveledPokemon {
    public MyPokemon(int level) {
        super(level);
    }
    @Override
    public PokemonType getType() { return PokemonType.Water; }
    @Override
    public String getName() { return "Squirtle"; }
}

// Task e: getType and getName which are overridden from the Pokemon interface;
// no other methods in this program are overridden.
